#pragma once
#include "grbc/spec.h"
#include <string>
#include <vector>

struct GeneratorResult {
    std::string file_name;
    std::string content;
};

struct GeneratorCompileCommand {
    LanguageType language_type;

    std::string source_file;
    std::string object_file;

    std::string compiler_flags;
};

struct GeneratorLinkExecutableCommand {
    std::vector<std::string> object_files;

    std::string output_exe;

    std::string linker_flags;
};

struct GeneratorTarget {
    std::vector<GeneratorCompileCommand> compile_commands;
    std::vector<GeneratorLinkExecutableCommand> link_executable_commands;
};

typedef GeneratorResult (*Generator_Run)();

struct Generator {
    /// Name of the generator, used in grbc_build(...)
    std::string name;

    /// Function pointer for this generator
    Generator_Run func;
};

/**
 * Ninja generator main function
 */
GeneratorResult ninja_generator();