#pragma once
#include "grbc/generator.h"
#include <string>

/**
 * Generate the build rule for compiling c++ files
 */
std::string ninja_build_rule_compile_cxx();

/**
 * Generate the build rule for compiling c files
 */
std::string ninja_build_rule_compile_cc();

/**
 * Generate the build rule for linking c++ object files
 */
std::string ninja_build_rule_link_cxx();

/**
 * Generate the build rule for linking c object files
 */
std::string ninja_build_rule_link_cc();

/**
 * Generate a line which builds the given file
 */
std::string
ninja_build_rule_compile_file(const GeneratorCompileCommand &compile_cmd);

/**
 * Default variables such as builddir
 */
std::string ninja_build_default_variables();

/**
 * Generate a line which links the given file
 */
std::string ninja_build_rule_link_exe_target(
    const GeneratorLinkExecutableCommand &link_cmd);